Subject: Re: [PATCH v6 0/7] builtin/repo: introduce structure subcommand

From: Patrick Steinhardt <[email-masked]>
Date: Fri, 24 Oct 2025 07:14:51 +0200

On Thu, Oct 23, 2025 at 01:54:17PM -0700, Junio C Hamano wrote:
> Justin Tobler <[email-masked]> writes:
> 
> > In this initial version, the "structure" subcommand only surfaces counts
> > of the various reference and object types in a repository. In a
> > follow-up series, I would like to introduce additional data points that
> > are present in git-sizer(1) such as largest objects, combined object
> > sizes by type, and other general repository shape information.
> >
> > Some other general features that would be nice to introduce eventually:
> >
> > - A "level of concern" meter for reported stats. This could indicate to
> >   users which stats may be worth looking into further.
> > - Links to OIDs of interesting objects that correspond to certain stats.
> > - Options to limit which references to use when evaluating the
> >   repository.
> >
> > Changes since V5:
> > - Instead of using `filter_refs()` to get an array of all references, we
> >   now use `refs_for_each_ref()` to count references, and setup OIDs for
> >   the path walk, in place. Doing this not only allows us to avoid
> >   wasting memory storing all the reference info, but also to display
> >   progress info to the user while iterating across the references
> >   initially.
> > - Add a prepatory patch to export `ref_kind_from_refname()` via
> >   "ref_filter.h" so we can reuse logic to categorize references while
> >   counting.
> 
> This round looked pretty well done to me.  Shall we declare victory
> and mark it for 'next' real soon now?

Agreed, I also think that this round looks good and is ready to be
merged down to next.

Thanks!

Patrick